with open('input.txt') as f, open('output.txt', 'wt') as fo:
    n, m = map(int, f.readline().split())
    employees = [set(map(int, line.split()[1:])) for line in f]

    max_set = set()
    for x in employees:
        max_set |= x

    levels, i = [], 0

    while employees:
        levels.append(max_set.copy())
        for x in employees:
            levels[i] &= x

        if not levels[i]:
            fo.write('-1')
            break

        employees = [x - levels[i] for x in employees if x - levels[i]]
        i += 1
    else:
        fo.write('{}\n'.format(len(levels)))
        for x in levels:
            fo.write('{} {}\n'.format(len(x), ' '.join(map(str, sorted(x)))))
